// VERMILION (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,d;

	// SYSTEM DISK/SAVE DISK
	struct fpos md[] =
	{
		{ 0x27, 0x01, 0x0700 }, // 
		{ 0x28, 0x01, 0x1000 }, // 
		{ 0x29, 0x01, 0x1800 }, // Ȃ񂩕
		{ 0x2a, 0x08, 0x0800 }, // 
		{ 0x2b, 0x01, 0x0600 }, // 
		{ 0x2b, 0x07, 0x0a00 }, // 
		{ 0x2c, 0x01, 0x2000 }, // 
		{ 0x2d, 0x02, 0x0700 }, // 
		{ 0x2d, 0x09, 0x0400 }, // 
		{ 0x2e, 0x01, 0x1000 }, // 
		{ 0x2f, 0x01, 0x0800 }, // 
		{ 0x2f, 0x09, 0x0800 }, // 
		{ 0x30, 0x01, 0x1000 }, // 
		{ 0x31, 0x01, 0x1000 }, // 
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		// fBXN
		disk.ReadDATA(0x4f, 0x27, 0x01, 0x01, 0x01, buff, 0x100);
		switch (buff[0xff])
		{
		case 'P':
			printf("SYSTEM DISK(SAVE DISK)F܂.\n");
			fcut("DRIVER1",0x00, 0x00, 0x00, 0x02, 0x01, 0x0000, 0x0f00);
			fcut("DRIVER2",0x27, 0x13, 0x01, 0x08, 0x01, 0x0000, 0x0800);
			for (i=0; md[i].size; i++)
			{
				sprintf(fname,"MUS%02d",i);
				fcut(fname, md[i].trk, md[i].trk>>1, md[i].trk&1, md[i].sec, 0x01, 0x0000, md[i].size);
			}
			break;

		case 'A':
			printf("DISK A F܂.\n");
			break;

		case 'B':
			printf("DISK B F܂.\n");
			break;

		case 'C':
			printf("DISK C F܂.\n");
			break;

		case 'D':
			printf("DISK D F܂.\n");
			break;

		default:
			printf("FłȂfBXNł.\n");
			break;
		}
	}
	return 0;
}

